Loading...
Searching...
No Matches
CommaOperator Struct Reference

`#include <openvdb_ax/ast/AST.h>`

Inheritance diagram for CommaOperator:

## Public Types

using | UniquePtr = std::unique_ptr<CommaOperator>

enum

NodeType {
TreeNode , StatementListNode , BlockNode , ConditionalStatementNode ,
CommaOperatorNode , LoopNode , KeywordNode , AssignExpressionNode ,
CrementNode , UnaryOperatorNode , BinaryOperatorNode , TernaryOperatorNode ,
CastNode , AttributeNode , FunctionCallNode , ExternalVariableNode ,
DeclareLocalNode , ArrayPackNode , ArrayUnpackNode , LocalNode ,
ValueBoolNode , ValueInt16Node , ValueInt32Node , ValueInt64Node ,
ValueFloatNode , ValueDoubleNode , ValueStrNode
}

| An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType. More...
using | Ptr = std::shared_ptr<Node>

## Public Member Functions

| CommaOperator ()
| Construct a new CommaOperator with an expr set.
| CommaOperator (Expression *expression)
| Construct a new CommaOperator with a single expression, transferring ownership of the expression to the CommaOperator and updating parent data on the expression. If the expression is a nullptr, it is ignored.
| CommaOperator (const std::vector< Expression * > &expressions)
| Construct a new CommaOperator from a vector of expression, transferring ownership of all valid expression to the CommaOperator and updating parent data on the statement. Only valid (non null) expression are added to the block.
| CommaOperator (const CommaOperator &other)
| Deep copy constructor for an CommaOperator, performing a deep copy on every held expression, ensuring parent information is updated.
| ~CommaOperator () override=default
CommaOperator * | copy () const override final
| The deep copy method for a Node.
NodeType | nodetype () const override
| Virtual method for accessing node type information.
const char * | nodename () const override
| Virtual method for accessing node name information.
const char * | subname () const override
| Virtual method for accessing node name information.
const Expression * | basetype () const override
| Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.
size_t | children () const override final
| Virtual method for accessing child information. Returns the number of children a given AST node owns.
const Expression * | child (const size_t i) const override final
| Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.
bool | replacechild (const size_t i, Node *node) override final
| Virtual method that attempted to replace a child at a given index with a provided node type.
size_t | size () const
| Alias for CommaOperator::children.
bool | empty () const
| Query whether this Expression list holds any valid expressions.
void | append (Expression *expr)
| Append an expression to this CommaOperator, transferring ownership to the CommaOperator and updating parent data on the expression. If the expression is a nullptr, it is ignored.
Name/Type
template<typename NodeT>
bool | isType () const
| Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype().
Child Queries
int64_t | childidx () const
| Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree).
Replacement
bool | replace (Node *node)
| In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.
Parent
const Node * | parent () const
| Access a const pointer to this nodes parent.
void | setParent (Node *parent)
| Set this node's parent. This is used during construction of an AST and should not be used.

## Member Typedef Documentation

## Ptr

using Ptr = std::shared_ptr<Node>

inherited

## UniquePtr

using UniquePtr = std::unique_ptr<CommaOperator>

## Member Enumeration Documentation

## NodeType

enum NodeType

inherited

An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType.

Note
  This is sometimes referred to as "manual RTTI". We use this technique combine with single dispatch due to opting for CRTP on the main visitor and no templated virtual method support in C++. i.e. no way to double dispatch: visit<template T>(Visitor<T>*)
  Abstract (pure-virtual) nodes are not listed here. Node::isType should be used to determine if a node is of a given abstract type.

Enumerator
TreeNode |
StatementListNode |
BlockNode |
ConditionalStatementNode |
CommaOperatorNode |
LoopNode |
KeywordNode |
AssignExpressionNode |
CrementNode |
UnaryOperatorNode |
BinaryOperatorNode |
TernaryOperatorNode |
CastNode |
AttributeNode |
FunctionCallNode |
ExternalVariableNode |
DeclareLocalNode |
ArrayPackNode |
ArrayUnpackNode |
LocalNode |
ValueBoolNode |
ValueInt16Node |
ValueInt32Node |
ValueInt64Node |
ValueFloatNode |
ValueDoubleNode |
ValueStrNode |

## Constructor & Destructor Documentation

## CommaOperator() [1/4]

CommaOperator | ( |  | ) |

inline

Construct a new CommaOperator with an expr set.

## CommaOperator() [2/4]

CommaOperator | ( | Expression * | expression | ) |

inline

Construct a new CommaOperator with a single expression, transferring ownership of the expression to the CommaOperator and updating parent data on the expression. If the expression is a nullptr, it is ignored.

Parameters

  expression | The Expression to construct from

## CommaOperator() [3/4]

CommaOperator | ( | const std::vector< Expression * > & | expressions | ) |

inline

Construct a new CommaOperator from a vector of expression, transferring ownership of all valid expression to the CommaOperator and updating parent data on the statement. Only valid (non null) expression are added to the block.

Parameters

  expressions | The vector of expressions to construct from

## CommaOperator() [4/4]

CommaOperator | ( | const CommaOperator & | other | ) |

inline

Deep copy constructor for an CommaOperator, performing a deep copy on every held expression, ensuring parent information is updated.

Parameters

  other | A const reference to another CommaOperator to deep copy

## ~CommaOperator()

~CommaOperator | ( |  | ) |

override default

## Member Function Documentation

## append()

void append | ( | Expression * | expr | ) |

inline

Append an expression to this CommaOperator, transferring ownership to the CommaOperator and updating parent data on the expression. If the expression is a nullptr, it is ignored.

## basetype()

const Expression * basetype | ( |  | ) | const

inline override virtual

Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.

Reimplemented from Node.

## child()

const Expression * child | ( | const size_t | i | ) | const

inline final override virtual

Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.

Implements Node.

## childidx()

int64_t childidx | ( |  | ) | const

inline inherited

Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree).

Returns
  The child index of this node

## children()

size_t children | ( |  | ) | const

inline final override virtual

Virtual method for accessing child information. Returns the number of children a given AST node owns.

Implements Node.

## copy()

CommaOperator * copy | ( |  | ) | const

inline final override virtual

The deep copy method for a Node.

Implements Expression.

## empty()

bool empty | ( |  | ) | const

inline

Query whether this Expression list holds any valid expressions.

Returns
  True if this node if empty, false otherwise

## isType()

template<typename NodeT>

bool isType | ( |  | ) | const

inline inherited

Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype().

Template Parameters

  NodeT | The node type to query against.

Returns
  True if this node is of the given type, false otherwise.

## nodename()

const char * nodename | ( |  | ) | const

inline override virtual

Virtual method for accessing node name information.

Implements Node.

## nodetype()

NodeType nodetype | ( |  | ) | const

inline override virtual

Virtual method for accessing node type information.

Implements Node.

## parent()

const Node * parent | ( |  | ) | const

inline inherited

Access a const pointer to this nodes parent.

Note
  Can be a nullptr if this is the top most node in an AST (usually a Tree)

Returns
  A const pointer to this node's parent node

## replace()

bool replace | ( | Node * | node | ) |

inline inherited

In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.

Note
  A replacement will fail if this node is the top most node within an AST hierarchy or if the provided node type is not a compatible type for the required abstract storage. For example, if this node is an Attribute being held on a BinaryOperator, only concrete nodes derived from an Expression can be used as a replacement.
  This method will dynamic_cast the provided node to check to see if it's a compatible type.

Parameters

  node | The node to insert on a successful replacement.

Returns
  True if the replacement was successful, resulting in destruction of this class and ownership transferal of the provided node. False otherwise, where this and the provided node are unchanged.

## replacechild()

bool replacechild | ( | const size_t | i,
|  | Node * | node )

inline final override virtual

Virtual method that attempted to replace a child at a given index with a provided node type.

Reimplemented from Node.

## setParent()

void setParent | ( | Node * | parent | ) |

inline inherited

Set this node's parent. This is used during construction of an AST and should not be used.

Parameters

  parent | The parent to set

## size()

size_t size | ( |  | ) | const

inline

Alias for CommaOperator::children.

## subname()

const char * subname | ( |  | ) | const

inline override virtual

Virtual method for accessing node name information.

Implements Node.